diff --git a/drupal7/sites/all/themes/mayo/theme-settings.php b/drupal7/sites/all/themes/mayo/theme-settings.php
index b5532c83..f0e3f9b4 100644
--- a/drupal7/sites/all/themes/mayo/theme-settings.php
+++ b/drupal7/sites/all/themes/mayo/theme-settings.php
@@ -115,66 +148,621 @@ function mayo_form_system_theme_settings_alter(&$form, &$form_state) {
     '#description' => '<img src="/' . drupal_get_path('theme', 'mayo') . '/images/page-layout.png" /><br />' . t('When the layout 2 is selected, or header background image is selected, header borders are not drawn to make it looks better.'),
   );
 
-  /*--------------- Advanced sidebar settings --------------*/
-  $form['layout']['sidebar'] = array(
+  /* --------------- Responsive sidebar layout settings -------------- */
+  /* -----------Big screen as in desktop pc monitor------------- */
+  $form['layout']['bigscreen'] = array(
     '#type' => 'fieldset',
-    '#title' => t('Sidebar layout settings'),
+    '#title' => t('Big Screen Sidebar layout'),
     '#collapsible' => TRUE,
     '#collapsed' => TRUE,
+    '#attributes' => array(
+      'class' => array('mayo-layout-form'),
+    ),
+  );
+
+    // Big screen Layout
+  $form['layout']['bigscreen']['bigscreen-layout-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Choose sidebar layout'),
   );
-  $form['layout']['sidebar']['sidebar_layout_style'] = array(
+    // Options
+
+  $form['layout']['bigscreen']['bigscreen-layout-wrapper']['bigscreen_layout'] = array(
+     '#type' => 'radios',
+     '#title' => t('<strong>Choose sidebar positions</strong>'),
+     '#default_value' => str_replace('-', '_', theme_get_setting('bigscreen_layout')),
+     '#options' => $bigscreen_options,
+  );
+
+  // Sidebars
+  $form['layout']['bigscreen']['bigscreen-sidebar-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Set sidebar widths'),
+    '#description' => t('<strong>Set the width of each sidebar</strong>'),
+    '#collapsible' => FALSE,
+  );
+
+  // Units
+  $form['layout']['bigscreen']['bigscreen-sidebar-wrapper']['bigscreen_sidebar_unit'] = array(
+    '#type' => 'select',
+    '#title' => t('Unit'),
+    '#default_value' => theme_get_setting('bigscreen_sidebar_unit'),
+    '#options' => $unit_options,
+  );
+
+  // Sidebar first
+  $form['layout']['bigscreen']['bigscreen-sidebar-wrapper']['bigscreen_sidebar_first'] = array(
+    '#type' => 'textfield',
+    '#title' => t('First sidebar'),
+    '#default_value' => check_plain(theme_get_setting('bigscreen_sidebar_first')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'required' => array(
+        array('input[name="bigscreen_layout"]' => array('value' => 'three_col_grail')),
+        array('input[name="bigscreen_layout"]' => array('value' => 'two_sidebars_left')),
+        array('input[name="bigscreen_layout"]' => array('value' => 'two_sidebars_right')),
+      ),
+    ),
+  );
+
+  // Sidebar second
+  $form['layout']['bigscreen']['bigscreen-sidebar-wrapper']['bigscreen_sidebar_second'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Second sidebar'),
+    '#default_value' => check_plain(theme_get_setting('bigscreen_sidebar_second')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'required' => array(
+        array('input[name="bigscreen_layout"]' => array('value' => 'three_col_grail')),
+        array('input[name="bigscreen_layout"]' => array('value' => 'two_sidebars_left')),
+        array('input[name="bigscreen_layout"]' => array('value' => 'two_sidebars_right')),
+      ),
+    ),
+  );
+
+  // Page width
+  $form['layout']['bigscreen']['bigscreen-width-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Set the page width'),
+    '#description' => t('<strong>Set the page width</strong>'),
+  );
+
+  // Unit
+  $form['layout']['bigscreen']['bigscreen-width-wrapper']['bigscreen_page_unit'] = array(
+    '#type' => 'select',
+    '#title' => t('Unit'),
+    '#default_value' => theme_get_setting('bigscreen_page_unit'),
+    '#options' => $unit_options,
+  );
+
+  // Width
+  $form['layout']['bigscreen']['bigscreen-width-wrapper']['bigscreen_page_width'] = array(
+    '#type'  => 'textfield',
+    '#title' => t('Page width'),
+    '#default_value' => check_plain(theme_get_setting('bigscreen_page_width')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#required' => TRUE,
+  );
+
+  // Media queries
+  $form['layout']['bigscreen']['media-queries-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Standard Screen Media Queries'),
+    '#weight' => 1,
+    '#attributes' => array(
+      'class' => array('at-media-queries'),
+    ),
+  );
+
+  // Media query
+  $form['layout']['bigscreen']['media-queries-wrapper']['bigscreen_media_query'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Media query for this layout'),
+    '#default_value' => check_plain(theme_get_setting('bigscreen_media_query')),
+    '#description' => t('Do not include @media, it\'s included automatically.'),
+    '#size' => 100,
+    '#required' => TRUE,
+  );
+
+  /* ****************************************************************************
+   *
+   * Tablet
+   *
+   * ************************************************************************** */
+
+  $form['layout']['tablet'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Tablet Sidebar Layout'),
+    '#description' => t('<h3>Tablet Layout</h3><p>Tablet devices such as iPad, Android and Windows tablets have two orientations - landscape and portrait, which can also be thought of as wide and narrow tablets. You can configure a different layout for each orientation.</p>'),
+    '#attributes' => array(
+      'class' => array('mayo-layout-form'),
+    ),
+    '#collapsible' => TRUE,
+    '#collapsed' => TRUE,
+  );
+
+  /* ******************
+   * Tablet landscape
+   * **************** */
+
+  $form['layout']['tablet']['landscape'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Landscape'),
+    '#description' => t('<h4>Landscape tablet <span class="field-description-info">(wide)</span></h4>'),
+    '#collapsible' => TRUE,
+    '#collapsed' => TRUE,
+  );
+
+  // Tablet landscape Layout options
+  $form['layout']['tablet']['landscape']['tablet-landscape-layout-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Choose sidebar layout'),
+  );
+
+  // Options
+  $form['layout']['tablet']['landscape']['tablet-landscape-layout-wrapper']['tablet_landscape_layout'] = array(
     '#type' => 'radios',
-    '#title' => t('Sidebar layout style'),
-    '#default_value' => theme_get_setting('sidebar_layout_style'),
-    '#options' => array(
-      1 => t('1. Sidebar first comes left, sidebar second comes right.'),
-      2 => t('2. Both sidebars come left.'),
-      3 => t('3. Both sidebars come right.'),
+    '#title' => t('<strong>Choose sidebar positions</strong>'),
+    '#default_value' => str_replace('-', '_', theme_get_setting('tablet_landscape_layout')),
+    '#options' => $tablet_landscape_options,
+  );
+
+  // Sidebars
+  $form['layout']['tablet']['landscape']['tablet-landscape-sidebar-width-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Set sidebar widths'),
+    '#description' => t('<strong>Set the width of each sidebar</strong>'),
+  );
+
+  // Units
+  $form['layout']['tablet']['landscape']['tablet-landscape-sidebar-width-wrapper']['tablet_landscape_sidebar_unit'] = array(
+    '#type' => 'select',
+    '#title' => t('Unit'),
+    '#default_value' => theme_get_setting('tablet_landscape_sidebar_unit'),
+    '#options' => $unit_options,
+  );
+
+  // Sidebar first
+  $form['layout']['tablet']['landscape']['tablet-landscape-sidebar-width-wrapper']['tablet_landscape_sidebar_first'] = array(
+    '#type' => 'textfield',
+    '#title' => t('First sidebar'),
+    '#default_value' => check_plain(theme_get_setting('tablet_landscape_sidebar_first')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'required' => array(
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'three_col_grail')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_left')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_left_stack')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_right')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_right_stack')),
+      ),
     ),
-    '#prefix' => '<img src="/' . drupal_get_path('theme', 'mayo') . '/images/sidebar-layout.png" />',
   );
-  $form['layout']['sidebar']['sidebar_first_width'] = array(
+
+  // Sidebar second
+  $form['layout']['tablet']['landscape']['tablet-landscape-sidebar-width-wrapper']['tablet_landscape_sidebar_second'] = array(
     '#type' => 'textfield',
-    '#title' => t('Sidebar first width'),
-    '#default_value' => theme_get_setting('sidebar_first_width'),
-    '#size' => 12,
-    '#maxlength' => 8,
-    '#description' => t('Specify the width of the sidebar first in % (15-40%). px value can not be used.'),
-    '#element_validate' => array('mayo_sidebar_width_validate'),
+    '#title' => t('Second sidebar'),
+    '#default_value' => check_plain(theme_get_setting('tablet_landscape_sidebar_second')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'invisible' => array(
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_left_stack')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_right_stack')),
+      ),
+      'required' => array(
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'three_col_grail')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_left')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_right')),
+      ),
+    ),
+  );
+
+  // Conditional messages for sidebar layouts
+  $form['layout']['tablet']['landscape']['tablet-landscape-sidebar-width-wrapper']['tablet-landscape-sidebar-message-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#states' => array(
+      'invisible' => array(
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'three_col_grail')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_left')),
+        array('input[name="tablet_landscape_layout"]' => array('value' => 'two_sidebars_right')),
+      ),
+    ),
   );
-  $form['layout']['sidebar']['sidebar_second_width'] = array(
+  $form['layout']['tablet']['landscape']['tablet-landscape-sidebar-width-wrapper']['tablet-landscape-sidebar-message-wrapper']['message'] = array(
+    '#markup' => t('<div class="description">In this layout <em>Second sidebar</em> wraps below.</div>'),
+  );
+
+  // Page width
+  $form['layout']['tablet']['landscape']['tablet-landscape-page-width-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Set the page width'),
+    '#description' => t('<strong>Set the page width</strong>'),
+  );
+
+  // Unit
+  $form['layout']['tablet']['landscape']['tablet-landscape-page-width-wrapper']['tablet_landscape_page_unit'] = array(
+    '#type' => 'select',
+    '#title' => t('Unit'),
+    '#default_value' => theme_get_setting('tablet_landscape_page_unit'),
+    '#options' => $unit_options,
+  );
+
+  // Width
+  $form['layout']['tablet']['landscape']['tablet-landscape-page-width-wrapper']['tablet_landscape_page_width'] = array(
+    '#type'  => 'textfield',
+    '#title' => t('Page width'),
+    '#default_value' => check_plain(theme_get_setting('tablet_landscape_page_width')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#required' => TRUE,
+  );
+
+  // Media Queries
+  $form['layout']['tablet']['landscape']['tablet-landscape-media-queries-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Tablet Landscape Media Queries'),
+    '#weight' => 1,
+    '#attributes' => array(
+      'class' => array(
+        'at-media-queries',
+      ),
+    ),
+  );
+
+  // Media query
+  $form['layout']['tablet']['landscape']['tablet-landscape-media-queries-wrapper']['tablet_landscape_media_query'] = array(
     '#type' => 'textfield',
-    '#title' => t('Sidebar second width'),
-    '#default_value' => theme_get_setting('sidebar_second_width'),
-    '#size' => 12,
-    '#maxlength' => 8,
-    '#description' => t('Specify the width of the sidebar first in % (15-40%). px value can not be used.'),
-    '#element_validate' => array('mayo_sidebar_width_validate'),
+    '#title' => t('Media query for this layout'),
+    '#default_value' => check_plain(theme_get_setting('tablet_landscape_media_query')),
+    '#description' => t('Do not include @media, it\'s included automatically.'),
+    '#size' => 100,
+    '#required' => TRUE,
   );
-  $form['layout']['sidebar']['note'] = array(
-    '#type' => 'item',
-    '#title' => t('Note:'),
-    '#markup' => t('Main contents width is automatically determined based on the width of the sidebar and number of sidebar used.'),
+
+
+  /* *****************
+   * Tablet portrait
+   * *************** */
+
+  $form['layout']['tablet']['portrait'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Portrait'),
+    '#description' => t('<h4>Portrait tablet <span class="field-description-info">(narrow)</span></h4>'),
+    '#collapsible' => TRUE,
+    '#collapsed' => TRUE,
+  );
+
+  // Tablet portrait Layout options
+  $form['layout']['tablet']['portrait']['tablet-portrait-layout-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Choose sidebar layout'),
+  );
+
+  // Options
+  $form['layout']['tablet']['portrait']['tablet-portrait-layout-wrapper']['tablet_portrait_layout'] = array(
+    '#type' => 'radios',
+    '#title' => t('<strong>Choose sidebar positions</strong>'),
+    '#default_value' => str_replace('-', '_', theme_get_setting('tablet_portrait_layout')),
+    '#options' => $tablet_portrait_options,
+  );
+
+  // Tablet portrait Sidebars
+  $form['layout']['tablet']['portrait']['tablet-portrait-sidebar-width-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Set sidebar widths'),
+    '#description' => t('<strong>Set the width of each sidebar</strong>'),
+    '#states' => array(
+      'invisible' => array('input[name="tablet_portrait_layout"]' => array('value' => 'one_col_stack')),
+    ),
+  );
+
+  // Units
+  $form['layout']['tablet']['portrait']['tablet-portrait-sidebar-width-wrapper']['tablet_portrait_sidebar_unit'] = array(
+    '#type' => 'select',
+    '#title' => t('Unit'),
+    '#default_value' => theme_get_setting('tablet_portrait_sidebar_unit'),
+    '#options' => $unit_options,
+  );
+
+  // Sidebar first
+  $form['layout']['tablet']['portrait']['tablet-portrait-sidebar-width-wrapper']['tablet_portrait_sidebar_first'] = array(
+    '#type' => 'textfield',
+    '#title' => t('First sidebar'),
+    '#default_value' => check_plain(theme_get_setting('tablet_portrait_sidebar_first')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'invisible' => array(
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'one_col_stack')),
+      ),
+      'required' => array(
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'one_col_vert')),
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'two_sidebars_left_stack')),
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'two_sidebars_right_stack')),
+      ),
+    ),
+  );
+
+  // Sidebar second
+  $form['layout']['tablet']['portrait']['tablet-portrait-sidebar-width-wrapper']['tablet_portrait_sidebar_second'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Second sidebar'),
+    '#default_value' => check_plain(theme_get_setting('tablet_portrait_sidebar_second')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'invisible' => array(
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'one_col_stack')),
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'two_sidebars_left_stack')),
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'two_sidebars_right_stack')),
+      ),
+      'required' => array(
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'one_col_vert')),
+      ),
+    ),
   );
 
+  // Conditional messages for sidebar layouts
+  $form['layout']['tablet']['portrait']['tablet-portrait-sidebar-width-wrapper']['tablet-portrait-sidebar-message-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#states' => array(
+      'invisible' => array(
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'one_col_vert')),
+        array('input[name="tablet_portrait_layout"]' => array('value' => 'one_col_stack')),
+      ),
+    ),
+  );
+  $form['layout']['tablet']['portrait']['tablet-portrait-sidebar-width-wrapper']['tablet-portrait-sidebar-message-wrapper']['message'] = array(
+    '#markup' => t('<div class="description">In this layout <em>Second sidebar</em> wraps below.</div>'),
+  );
+
+  // Tablet portrait Page width
+  $form['layout']['tablet']['portrait']['tablet-portrait-page-width-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Set the page width'),
+    '#description' => t('<strong>Set the page width</strong>'),
+  );
+
+  // Unit
+  $form['layout']['tablet']['portrait']['tablet-portrait-page-width-wrapper']['tablet_portrait_page_unit'] = array(
+    '#type' => 'select',
+    '#title' => t('Unit'),
+    '#default_value' => theme_get_setting('tablet_portrait_page_unit'),
+    '#options' => $unit_options,
+  );
+
+  // Width
+  $form['layout']['tablet']['portrait']['tablet-portrait-page-width-wrapper']['tablet_portrait_page_width'] = array(
+    '#type'  => 'textfield',
+    '#title' => t('Page width'),
+    '#default_value' => check_plain(theme_get_setting('tablet_portrait_page_width')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#required' => TRUE,
+  );
+
+  // Tablet portrait Media queries
+  $form['layout']['tablet']['portrait']['tablet-portrait-media-queries-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Tablet Portrait Media Queries'),
+    '#weight' => 1,
+    '#attributes' => array(
+      'class' => array('at-media-queries'),
+    ),
+  );
+
+  // Media query
+  $form['layout']['tablet']['portrait']['tablet-portrait-media-queries-wrapper']['tablet_portrait_media_query'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Media query for this layout'),
+    '#default_value' => check_plain(theme_get_setting('tablet_portrait_media_query')),
+    '#description' => t('Do not include @media, it\'s included automatically.'),
+    '#size' => 100,
+    '#required' => TRUE,
+  );
+  /* ****************************************************************************
+   *
+   * Smalltouch
+   *
+   * ************************************************************************** */
+
+  $form['layout']['smalltouch'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Smalltouch Sidebar Layout'),
+    '#description' => t('<h3>Smalltouch Layout</h3><p>Smalltouch devices such as iPhone, Android and Windows phones have two orientations - landscape and portrait, which can also be thought of as wide and arrow smalltouch devices. You can configure a layout for landscape orientation only - portrait orientation (narrow) will always display in one column (all regions full width and stacked) with sidebars below the main content.</p>'),
+    '#attributes' => array(
+      'class' => array('mayo-layout-form'),
+    ),
+    '#collapsible' => TRUE,
+    '#collapsed' => TRUE,
+  );
+
+  /* **********************
+   * Smalltouch landscape
+   * ******************** */
+
+  $form['layout']['smalltouch']['landscape'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Landscape'),
+    '#description' => t('<h4>Landscape smalltouch <span class="field-description-info">(wide)</span></h4>'),
+    '#collapsible' => TRUE,
+    '#collapsed' => TRUE,
+  );
+
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-layout-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Choose sidebar layout'),
+  );
+
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-layout-wrapper']['smalltouch_landscape_layout'] = array(
+    '#type' => 'radios',
+    '#title' => t('<strong>Choose sidebar positions</strong>'),
+    '#default_value' => theme_get_setting('smalltouch_landscape_layout') ? str_replace('-', '_', theme_get_setting('smalltouch_landscape_layout')) : str_replace('-', '_', theme_get_setting('smartphone_landscape_layout')),
+    '#options' => $smalltouch_landscape_options,
+  );
+
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-sidebar-width-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Set sidebar widths'),
+    '#description' => t('<strong>Set the width of each sidebar</strong>'),
+    '#states' => array(
+      '!visible' => array('input[name="smalltouch_landscape_layout"]' => array('value' => 'one_col_stack')),
+    ),
+  );
+
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-sidebar-width-wrapper']['smalltouch_landscape_sidebar_unit'] = array(
+    '#type' => 'select',
+    '#title' => t('Unit'),
+    '#default_value' => theme_get_setting('smalltouch_landscape_sidebar_unit') ? theme_get_setting('smalltouch_landscape_sidebar_unit') : theme_get_setting('smartphone_landscape_sidebar_unit'),
+    '#options' => $unit_options,
+  );
 
-  /*--------------- Style settings --------------*/
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-sidebar-width-wrapper']['smalltouch_landscape_sidebar_first'] = array(
+    '#type' => 'textfield',
+    '#title' => t('First sidebar'),
+    '#default_value' => theme_get_setting('smalltouch_landscape_sidebar_first') ? check_plain(theme_get_setting('smalltouch_landscape_sidebar_first')) : check_plain(theme_get_setting('smartphone_landscape_sidebar_first')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'required' => array('input[name="smalltouch_landscape_layout"]' => array('value' => 'one_col_vert')),
+    ),
+  );
+
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-sidebar-width-wrapper']['smalltouch_landscape_sidebar_second'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Second sidebar'),
+    '#default_value' => theme_get_setting('smalltouch_landscape_sidebar_second') ? check_plain(theme_get_setting('smalltouch_landscape_sidebar_second')) : check_plain(theme_get_setting('smartphone_landscape_sidebar_second')),
+    '#size' => 4,
+    '#maxlenght' => 4,
+    '#states' => array(
+      'required' => array('input[name="smalltouch_landscape_layout"]' => array('value' => 'one_col_vert')),
+    ),
+  );
+
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-media-queries-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Smalltouch Landscape Media Queries'),
+    '#weight' => 1,
+    '#attributes' => array(
+      'class' => array('at-media-queries'),
+    ),
+  );
+
+  $form['layout']['smalltouch']['landscape']['smalltouch-landscape-media-queries-wrapper']['smalltouch_landscape_media_query'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Media query for this layout'),
+    '#default_value' => theme_get_setting('smalltouch_landscape_media_query') ? check_plain(theme_get_setting('smalltouch_landscape_media_query')) : check_plain(theme_get_setting('smartphone_landscape_media_query')),
+    '#description' => t('Do not include @media, it\'s included automatically.'),
+    '#size' => 100,
+    //'#required' => TRUE,
+  );
+
+  // Pass hidden values to the sumbit function, these values are required but the user can't change them via the UI
+  $form['layout']['smalltouch']['landscape']['hidden']['smalltouch_landscape_page_width'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_landscape_page_width') ? check_plain(theme_get_setting('smalltouch_landscape_page_width')) : check_plain(theme_get_setting('smartphone_landscape_page_width')),
+  );
+  $form['layout']['smalltouch']['landscape']['hidden']['smalltouch_landscape_page_unit'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_landscape_page_unit') ? theme_get_setting('smalltouch_landscape_page_unit') : theme_get_setting('smartphone_landscape_page_unit'),
+  );
+
+  /* *********************
+   * Smalltouch portrait
+   * ******************* */
+
+  $form['layout']['smalltouch']['portrait'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Portrait'),
+    '#description' => t('<h4>Portrait smalltouch <span class="field-description-info">(narrow)</span></h4><div class="smalltouch-portrait-layout">One column</div><p>The smalltouch portrait layout always displays in one column with sidebars stacked horizontally below the main content. All widths are always 100%.</p>'),
+    '#collapsible' => TRUE,
+    '#collapsed' => TRUE,
+  );
+
+  $form['layout']['smalltouch']['portrait']['smalltouch-portrait-media-queries-wrapper'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Smalltouch Portrait Media Queries'),
+    '#weight' => 1,
+    '#attributes' => array(
+      'class' => array('at-media-queries'),
+    ),
+  );
+
+  $form['layout']['smalltouch']['portrait']['smalltouch-portrait-media-queries-wrapper']['smalltouch_portrait_media_query'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Media query for this layout'),
+    '#default_value' => theme_get_setting('smalltouch_portrait_media_query') ? check_plain(theme_get_setting('smalltouch_portrait_media_query')) : check_plain(theme_get_setting('smartphone_portrait_media_query')),
+    '#description' => t('Do not include @media, it\'s included automatically.'),
+    '#size' => 100,
+  );
+
+  // Pass hidden values to the sumbit function, these values are required but the user can't change them via the UI
+  $form['layout']['smalltouch']['portrait']['hidden']['smalltouch_portrait_page_width'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_portrait_page_width') ? check_plain(theme_get_setting('smalltouch_portrait_page_width')) : check_plain(theme_get_setting('smartphone_portrait_page_width')),
+  );
+
+  $form['layout']['smalltouch']['portrait']['hidden']['smalltouch_portrait_page_unit'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_portrait_page_unit') ? theme_get_setting('smalltouch_portrait_page_unit') : theme_get_setting('smartphone_portrait_page_unit'),
+  );
+
+  $form['layout']['smalltouch']['portrait']['hidden']['smalltouch_portrait_sidebar_first'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_portrait_sidebar_first') ? check_plain(theme_get_setting('smalltouch_portrait_sidebar_first')) : check_plain(theme_get_setting('smartphone_portrait_sidebar_first')),
+  );
+
+  $form['layout']['smalltouch']['portrait']['hidden']['smalltouch_portrait_sidebar_second'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_portrait_sidebar_second') ? check_plain(theme_get_setting('smalltouch_portrait_sidebar_second')) : check_plain(theme_get_setting('smartphone_portrait_sidebar_second')),
+  );
+
+  $form['layout']['smalltouch']['portrait']['hidden']['smalltouch_portrait_sidebar_unit'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_portrait_sidebar_unit') ? check_plain(theme_get_setting('smalltouch_portrait_sidebar_unit')) : check_plain(theme_get_setting('smartphone_portrait_sidebar_unit')),
+  );
+
+  $form['layout']['smalltouch']['portrait']['hidden']['smalltouch_portrait_layout'] = array(
+    '#type' => 'hidden',
+    '#default_value' => theme_get_setting('smalltouch_portrait_layout') ? str_replace('-', '_', theme_get_setting('smalltouch_portrait_layout')) : str_replace('-', '_', theme_get_setting('smartphone_portrait_layout')),
+  );
+
+   /* --------------- Style settings -------------- */
   $form['style'] = array(
     '#type' => 'fieldset',
     '#title' => t('Style settings'),
     '#collapsible' => TRUE,
     '#collapsed' => TRUE,
   );
+  $form['style']['legacy_superfish_styles'] = array(
+    '#type' => 'checkbox',
+    '#title' => t('Use old legacy MAYO styles for Superfish.'),
+    '#default_value' => theme_get_setting('legacy_superfish_styles'),
+    '#description' => t('Check here if you want to add mayo-superfish.css.'),
+  );
+  $form['style']['superfish_note'] = array(
+    '#type' => 'item',
+    '#title' => t('Note:'),
+    '#markup' => t('Use this only when coming from the older non-responsive versions of MAYO
+     and your Superfish menu is broken without it. If you haven\'t been using Superfish or are
+     installing MAYO for the first time you shouldn\'t need it and can leave it unchecked.'),
+  );
   $form['style']['round_corners'] = array(
     '#type' => 'select',
     '#title' => t('Content box round corners'),
     '#default_value' => theme_get_setting('round_corners'),
-    '#description' => t('Make the corner of sidebar block and/or node rounded.<br/><b>Note:</b> This feature does not work with IE. Currently, it works with Safari, Firefox, Opera, Google Chrome.'),
+    '#description' => t('Make the corner of sidebar block and/or node rounded.'),
     '#options' => array(
-      0 => t('No round corners'),
-      1 => t('Sidebar block only'),
-      2 => t('Node only'),
-      3 => t('Both sidebar block and node'),
+      'rc-0' => t('No round corners'),
+      'rc-1' => t('Sidebar block only'),
+      'rc-2' => t('Node only'),
+      'rc-3' => t('Both sidebar block and node'),
     ),
     '#suffix' => '<img src="/' . drupal_get_path('theme', 'mayo') . '/images/round-corners.png" /><br />',
   );
@@ -195,7 +783,23 @@ function mayo_form_system_theme_settings_alter(&$form, &$form_state) {
     '#markup' => t('When the menubar type 2 is selected, the menu text color, menu highlight color, menu divier color from the color set are ignored and the fixed colors that match to the menubar are used instead.  Besides, highlight color and menu divider color from the color set are still used for other places such as tabs and sub-menubar for superfish and nice_menus menu.'),
   );
 
-  /*--------------- Advanced header settings --------------*/
+  $form['style']['menubar_background'] = array(
+    '#type' => 'checkbox',
+    '#title' => t('Allow Menubar background color.'),
+    '#default_value' => theme_get_setting('menubar_background'),
+    '#description' => t('Add your own hex background color below.'),
+  );
+
+  $form['style']['menubar_bg_value'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Meubar background color'),
+    '#default_value' => theme_get_setting('menubar_bg_value'),
+    '#size' => 7,
+    '#maxlength' => 7,
+    '#description' => t('Specify the background color for the menubar. This setting is used only when the <em>Allow Meubar background</em> option is checked above.'),
+  );
+
+  /* --------------- Advanced header settings -------------- */
   $form['adv_header'] = array(
     '#type' => 'fieldset',
     '#title' => t('Advanced header settings'),
@@ -337,7 +941,7 @@ function mayo_form_system_theme_settings_alter(&$form, &$form_state) {
     '#suffix' => '<img src="/' . drupal_get_path('theme', 'mayo') . '/images/watermark-sample.png" /><br />',
   );
 
-  /*--------------- Misellanenous settings --------------*/
+  /* --------------- Misellanenous settings -------------- */
   $form['misc'] = array(
     '#type' => 'fieldset',
     '#title' => t('Miscellaneous settings'),
